// 4. Attente entre threads via ressources : wait()

//	Client

import java.io.*;
import java.security.*;

public class CbDigest implements Runnable {
	private File input;
	private byte[] digest;
	private CbDigestServer server; // objet de notification

	public CbDigest (File input, CbDigestServer server) {
		this.input = input;
		this.server = server;
	}

	public void run() {
	  synchronized (server) {
		try {
			MessageDigest sha = MessageDigest.getInstance("SHA");
			DigestInputStream din = new DigestInputStream(
				new FileInputStream(input),
				sha
			);
			int b;
			while ((b = din.read()) != -1);
			din.close();
			byte[] digest = sha.digest();
			server.setDigest(digest);
			server.notify();			// notification
		}
		catch(IOException e) {
			System.err.println(e);
		}
		catch(NoSuchAlgorithmException  e) {
			System.err.println(e);
		}
	  }
}	}
